//+------------------------------------------------------------------+
//|                                            SSL channel chart.mq4 |
//|                                                           mladen |
//|                                                                  |
//| initial SSL for metatrader developed by Kalenzo                  |
//+------------------------------------------------------------------+
//mtf2008fxtsd

#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LightCoral
#property indicator_width1  5
#property indicator_color2  DarkSeaGreen
#property indicator_width2  5
#property indicator_color3  DarkSlateGray
#property indicator_width3  2
#property indicator_color4  DarkSlateGray
#property indicator_width4  2

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
extern int             Lb              = 10;
extern ENUM_MA_METHOD  sslMA_method    = 0;   //default SMA
extern bool            alertsOn        = false;
extern bool            alertsOnCurrent = true;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsNotify    = false;
extern bool            alertsEmail     = false;
extern string          soundFile       = "alert2.wav";

double ssld[];
double sslu[];
double Hlv[];
double Fill_0[];
double Fill_1[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,Fill_0); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Fill_1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ssld);
   SetIndexBuffer(3,sslu); 
   SetIndexBuffer(4,Hlv);
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   
IndicatorShortName(timeFrameToString(TimeFrame)+"  SSL");
return(0);
}

//
//
//
//
//
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
            if (returnBars)  { Fill_0[0] = limit+1; return(0); } 
            
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {  
      for(int i=limit; i>=0; i--) 
      {
         Hlv[i] = Hlv[i+1];
         if(Close[i]>iMA(NULL,0,Lb,0,sslMA_method,PRICE_HIGH,i+1)) Hlv[i] =  1;
         if(Close[i]<iMA(NULL,0,Lb,0,sslMA_method,PRICE_LOW,i+1))  Hlv[i] = -1;
      
         if(Hlv[i] == -1)
         {
           ssld[i] = iMA(NULL,0,Lb,0,MODE_SMA,PRICE_HIGH,i+1);
           sslu[i] = iMA(NULL,0,Lb,0,MODE_SMA,PRICE_LOW ,i+1);
         }               
         else
         {
           ssld[i] = iMA(NULL,0,Lb,0,MODE_SMA,PRICE_LOW ,i+1);
           sslu[i] = iMA(NULL,0,Lb,0,MODE_SMA,PRICE_HIGH,i+1);
         } 
     
           Fill_0[i] = ssld[i] ;
           Fill_1[i] = sslu[i] ;      
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (Hlv[whichBar] != Hlv[whichBar+1])
      {
         if (Hlv[whichBar] == 1) doAlert(whichBar,"up");
         if (Hlv[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
   return(0);
   }
   
   //
   //
   //
   //
   //
 
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
    for(i=limit; i >= 0; i--)  
    {
       int y = iBarShift(NULL,TimeFrame,Time[i]);
          ssld[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Lb,sslMA_method,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
          sslu[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Lb,sslMA_method,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
          Fill_0[i] = ssld[i];
          Fill_1[i] = sslu[i]; 
    }
return(0); 
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SSL_fill_channel ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " SSL_fill_channel "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}